ALTER TABLE CONCEPT ADD CL_ID number(18) 
;
CREATE TABLE METADATA_ATTRIBUTE(
	MTD_ATTR_ID number(18) NOT NULL,
	ID varchar2(50) NOT NULL,
	MIN_OCCURS number(10) NULL,
	MAX_OCCURS number(10) NULL,
	IS_PRESENTATIONAL Number(3) NULL,
	PARENT number(18) NULL,
	CON_ID number(18) NOT NULL,
	CL_ID number(18) NULL,
	RS_ID number(18) NOT NULL,
 PRIMARY KEY (MTD_ATTR_ID) 
) 
;

CREATE TABLE ITEM_SCHEME(
	ITEM_SCHEME_ID number(18) NOT NULL,
 PRIMARY KEY (ITEM_SCHEME_ID) 
) 
;


CREATE TABLE CONCEPT_ROLE(
	COMP_ID number(18) NOT NULL,
	CON_ID number(18) NOT NULL,
 PRIMARY KEY (COMP_ID,CON_ID) 
) 
;

CREATE TABLE TARGET_OBJECT(
	TARGET_OBJ_ID number(18) NOT NULL,
	ID varchar2(50) NOT NULL,
	ITEM_SCHEME_ID number(18) NULL,
	MDT_ID number(18) NOT NULL,
	TYPE varchar2(50) NOT NULL,
PRIMARY KEY (TARGET_OBJ_ID) 
) 
;

CREATE TABLE COMPONENT_COMMON(
	COMP_ID number(18) NOT NULL,
PRIMARY KEY (COMP_ID) 
) 
;

Insert into COMPONENT_COMMON (select comp_id from COMPONENT)
;


CREATE OR REPLACE TRIGGER COMPONENT_COMMON_COMP_ID
BEFORE INSERT
ON COMPONENT_COMMON
FOR EACH ROW
BEGIN
  SELECT COMPONENT_SEQ.NEXTVAL
  INTO :NEW.COMP_ID
  FROM DUAL;
END;
/



CREATE TABLE STRUCTURE_USAGE(
	SU_ID number(18) NOT NULL,
  PRIMARY KEY (SU_ID) 
) 
;

 
CREATE TABLE METADATA_STRUCTURE_DEFINITION(
	MSD_ID number(18) NOT NULL,
PRIMARY KEY (MSD_ID) 
) 
;

CREATE TABLE METADATA_TARGET(
	MDT_ID number(18) NOT NULL,
	MSD_ID number(18) NOT NULL,
PRIMARY KEY (MDT_ID) 
) 
;

CREATE TABLE METADATAFLOW(
	MSD_ID number(18) NOT NULL,
	MDF_ID number(18) NOT NULL,
 PRIMARY KEY (MDF_ID) 
) 
;

CREATE TABLE REPORT_STRUCTURE(
	RS_ID number(18) NOT NULL,
	MSD_ID number(18) NOT NULL,
PRIMARY KEY (RS_ID) 
) 
;

CREATE TABLE REPORT_STRUCTURE_META_TARGET(
	RS_ID number(18) NOT NULL,
	MDT_ID number(18) NOT NULL,
  PRIMARY KEY (RS_ID,MDT_ID) 
) 
;

CREATE TABLE CONCEPT_TEXT_FORMAT(
	CON_ID number(18) NOT NULL,
    FACET_TYPE_ENUM number(18) NOT NULL,
    FACET_VALUE nvarchar2(1024),
 PRIMARY KEY (CON_ID) 
) 
;

CREATE TABLE PROVISION_AGREEMENT(
	PA_ID number(18) NOT NULL,
	SU_ID number(18) NOT NULL,
	DP_ID number(18) NOT NULL,
  PRIMARY KEY (PA_ID) 
) 
;


Insert into ITEM_SCHEME 
SELECT CL_ID FROM CODELIST
UNION
SELECT DC_SCH_ID FROM DATACONSUMER_SCHEME
UNION
SELECT DP_SCH_ID FROM DATAPROVIDER_SCHEME
UNION
SELECT ORG_UNIT_SCH_ID FROM ORGANISATION_UNIT_SCHEME
UNION 
SELECT CON_SCH_ID FROM CONCEPT_SCHEME
UNION
SELECT CAT_SCH_ID FROM CATEGORY_SCHEME
UNION
SELECT AG_SCH_ID FROM AGENCY_SCHEME
;


INSERT INTO STRUCTURE_USAGE
SELECT DF_ID FROM DATAFLOW
;

ALTER TABLE CONCEPT ADD CONSTRAINT CONCEPT_CODELIST 
	FOREIGN KEY (CL_ID) REFERENCES CODELIST (CL_ID)
;

ALTER TABLE DATAFLOW DROP CONSTRAINT FK_DATAFLOW_ARTEFACT
;

ALTER TABLE CATEGORY_SCHEME DROP CONSTRAINT CAT_SCH_ART_ID
;

ALTER TABLE CODELIST DROP CONSTRAINT CL_ID
;

ALTER TABLE CONCEPT_SCHEME DROP CONSTRAINT CON_SCH_ART_ID
;

ALTER TABLE AGENCY_SCHEME DROP CONSTRAINT FK_AGENCY_SCHEME_ARTEFACT
;

ALTER TABLE DATACONSUMER_SCHEME DROP CONSTRAINT FK_DATACONSUMER_SCHEME_ART_ID
;

ALTER TABLE DATAPROVIDER_SCHEME DROP CONSTRAINT FK_DATAPROVIDER_SCHEME_ART_ID
;

ALTER TABLE ORGANISATION_UNIT_SCHEME DROP CONSTRAINT FK_ORGANISATION_UNIT_SCH_ART
;

ALTER TABLE CATEGORY_SCHEME  ADD  CONSTRAINT CAT_SCH_ITM_SCH_ID FOREIGN KEY(CAT_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

ALTER TABLE PROVISION_AGREEMENT  ADD  CONSTRAINT FK_PROVISION_AGREEMENT_ART FOREIGN KEY(PA_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

ALTER TABLE PROVISION_AGREEMENT  ADD  CONSTRAINT FK_PROV_AGREE_STRUCT_USAGE FOREIGN KEY(SU_ID)
REFERENCES STRUCTURE_USAGE (SU_ID)
;

ALTER TABLE PROVISION_AGREEMENT  ADD  CONSTRAINT FK_PROV_AGREE_DP FOREIGN KEY(DP_ID)
REFERENCES DATAPROVIDER (DP_ID)
;

ALTER TABLE DATAFLOW   ADD  CONSTRAINT FK_DATAFLOW_STRUCTURE_USAGE FOREIGN KEY(DF_ID)
REFERENCES STRUCTURE_USAGE (SU_ID)
ON DELETE CASCADE
;

ALTER TABLE STRUCTURE_USAGE ADD CONSTRAINT FK_STRUCTURE_USAGE_ARTEFACT  FOREIGN KEY(SU_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

ALTER TABLE CONCEPT_TEXT_FORMAT  ADD  CONSTRAINT FK_CONC_TEXT_FORMAT_CONCEPT FOREIGN KEY(CON_ID)
REFERENCES CONCEPT (CON_ID)
;

ALTER TABLE CONCEPT_TEXT_FORMAT  ADD  CONSTRAINT FK_CONC_TEXT_FORMAT_ENUM FOREIGN KEY(FACET_TYPE_ENUM)
REFERENCES ENUMERATIONS (ENUM_ID)
;

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_CODELIST FOREIGN KEY(CL_ID)
REFERENCES CODELIST (CL_ID)
;

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_COMP_COMMON FOREIGN KEY(MTD_ATTR_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
;

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_CONCEPT FOREIGN KEY(CON_ID)
REFERENCES CONCEPT (CON_ID)
;

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_MD_ATTR FOREIGN KEY(PARENT)
REFERENCES METADATA_ATTRIBUTE (MTD_ATTR_ID)
;

ALTER TABLE METADATA_ATTRIBUTE  ADD  CONSTRAINT FK_MD_ATTR_REPORT_STRUCTURE FOREIGN KEY(RS_ID)
REFERENCES REPORT_STRUCTURE (RS_ID)
;


ALTER TABLE AGENCY_SCHEME  ADD  CONSTRAINT FK_AGENCY_SCHEME_ITEM_SCH FOREIGN KEY(AG_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

ALTER TABLE CONCEPT_SCHEME   ADD  CONSTRAINT CON_SCH_ITM_SCH_ID FOREIGN KEY(CON_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

ALTER TABLE DATACONSUMER_SCHEME   ADD  CONSTRAINT FK_DCONSUMER_SCH_ITM_SCH_ID FOREIGN KEY(DC_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

ALTER TABLE DATAPROVIDER_SCHEME   ADD  CONSTRAINT FK_DPROVIDER_SCH_ITM_SCH_ID FOREIGN KEY(DP_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

ALTER TABLE ITEM_SCHEME   ADD  CONSTRAINT FK_ITEM_SCHEME_ARTEFACT FOREIGN KEY(ITEM_SCHEME_ID)
REFERENCES ARTEFACT (ART_ID)
ON DELETE CASCADE
;

ALTER TABLE CODELIST   ADD  CONSTRAINT CL_ID_ITM_SCM FOREIGN KEY(CL_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;

ALTER TABLE ORGANISATION_UNIT_SCHEME   ADD  CONSTRAINT FK_ORG_UNIT_SCH_ITM_SCH FOREIGN KEY(ORG_UNIT_SCH_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
ON DELETE CASCADE
;


ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TAR_OBJ_TO_ITEM_SCHEME FOREIGN KEY(ITEM_SCHEME_ID)
REFERENCES ITEM_SCHEME (ITEM_SCHEME_ID)
;

ALTER TABLE CONCEPT_ROLE   ADD  CONSTRAINT FK_CONCEPT_ROLE_COMPONENT FOREIGN KEY(COMP_ID)
REFERENCES COMPONENT (COMP_ID)
ON DELETE CASCADE
;


ALTER TABLE CONCEPT_ROLE   ADD  CONSTRAINT FK_CONCEPT_ROLE_CONCEPT FOREIGN KEY(CON_ID)
REFERENCES CONCEPT (CON_ID)
;

ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TAR_OBJ_To_CCOMMON FOREIGN KEY(TARGET_OBJ_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
;


ALTER TABLE TARGET_OBJECT   ADD  CONSTRAINT FK_TARGET_OBJECT_To_MDT FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
;


ALTER TABLE COMPONENT_ANNOTATION   ADD  CONSTRAINT FK_COMP_ANN_COMPONENT_COMMON FOREIGN KEY(COMP_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
;


ALTER TABLE COMPONENT   ADD  CONSTRAINT FK_COMPONENT_COMMON_COMPONENT FOREIGN KEY(COMP_ID)
REFERENCES COMPONENT_COMMON (COMP_ID)
ON DELETE CASCADE
;


ALTER TABLE METADATAFLOW   ADD  CONSTRAINT FK_MDFLOW_MD_STRUC_DEFINITION FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
;


ALTER TABLE METADATAFLOW   ADD  CONSTRAINT FK_MDFLOW_STRUCT_USAGE FOREIGN KEY(MDF_ID)
REFERENCES STRUCTURE_USAGE (SU_ID)
ON DELETE CASCADE
;

ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_ITEM FOREIGN KEY(MDT_ID)
REFERENCES ITEM (ITEM_ID)
;


ALTER TABLE METADATA_TARGET   ADD  CONSTRAINT FK_METADATA_TARGET_TO_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
;

ALTER TABLE METADATA_STRUCTURE_DEFINITION   ADD  CONSTRAINT FK_MSD_TO_ARTEFACT FOREIGN KEY(MSD_ID)
REFERENCES ARTEFACT (ART_ID)
;

ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_ITEM FOREIGN KEY(RS_ID)
REFERENCES ITEM (ITEM_ID)
;


ALTER TABLE REPORT_STRUCTURE   ADD  CONSTRAINT FK_REPORT_STRUCTURE_To_MSD FOREIGN KEY(MSD_ID)
REFERENCES METADATA_STRUCTURE_DEFINITION (MSD_ID)
;


ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRUCT_META_TAR_MD_TAR FOREIGN KEY(MDT_ID)
REFERENCES METADATA_TARGET (MDT_ID)
;


ALTER TABLE REPORT_STRUCTURE_META_TARGET   ADD  CONSTRAINT FK_REP_STRU_META_TAR_REP_STRU FOREIGN KEY(RS_ID)
REFERENCES REPORT_STRUCTURE (RS_ID)
;

ALTER TABLE TEXT_FORMAT DROP CONSTRAINT FK_TEXT_FORMAT_COMPONENT
;

ALTER TABLE TEXT_FORMAT ADD CONSTRAINT
	FK_TEXT_FORMAT_COMPONENT FOREIGN KEY
	(COMP_ID) REFERENCES COMPONENT_COMMON (COMP_ID) ON DELETE CASCADE
;

ALTER TABLE ATT_MEASURE DROP CONSTRAINT FK_ATT_MEASURE_ATT
;

ALTER TABLE ATT_MEASURE ADD CONSTRAINT FK_ATT_MEASURE_ATT 
	FOREIGN KEY (ATT_COMP_ID) REFERENCES COMPONENT (COMP_ID)
	ON DELETE CASCADE
;


CREATE OR REPLACE PROCEDURE INSERT_COMPONENT(
	p_type IN varchar2,
	p_id IN varchar2,
	p_dsd_id IN number,
	p_con_id IN number,
	p_cl_id IN number DEFAULT NULL,
	p_con_sch_id IN number DEFAULT NULL,
	p_is_freq_dim IN number DEFAULT NULL,
	p_is_measure_dim IN number DEFAULT NULL,
	p_att_ass_level IN varchar2 DEFAULT NULL,
	p_att_status IN varchar2 DEFAULT NULL,
	p_att_is_time_format IN number DEFAULT NULL,
	p_xs_attlevel_ds IN number DEFAULT NULL,
	p_xs_attlevel_group IN number DEFAULT NULL,
	p_xs_attlevel_section IN number DEFAULT NULL,
	p_xs_attlevel_obs IN number DEFAULT NULL,
	p_xs_measure_code IN varchar2 DEFAULT NULL,
	p_pk OUT NUMBER) 
AS
BEGIN
	INSERT_COMPONENT_COMMON(p_pk);
	insert into COMPONENT (COMP_ID,ID, TYPE, DSD_ID, CON_ID, CL_ID, IS_FREQ_DIM, IS_MEASURE_DIM, ATT_ASS_LEVEL, ATT_STATUS, ATT_IS_TIME_FORMAT, XS_ATTLEVEL_DS, XS_ATTLEVEL_GROUP, XS_ATTLEVEL_SECTION, XS_ATTLEVEL_OBS, XS_MEASURE_CODE, CON_SCH_ID) 
		values (p_pk,p_id, p_type, p_dsd_id, p_con_id, p_cl_id, p_is_freq_dim, p_is_measure_dim, p_att_ass_level, p_att_status, p_att_is_time_format, p_xs_attlevel_ds, p_xs_attlevel_group, p_xs_attlevel_section, p_xs_attlevel_obs, p_xs_measure_code, p_con_sch_id);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_CONCEPT(
	p_id IN item.id%type,
	p_con_sch_id IN CONCEPT.CON_SCH_ID%type,
	p_parent_con_id IN CONCEPT.PARENT_CONCEPT_ID%type,
	p_cl_id IN number,
	p_pk OUT item.item_id%type)
AS
BEGIN

		insert into ITEM (ITEM_ID, ID) VALUES (ITEM_SEQ.nextval, p_id);
		select ITEM_SEQ.currval into p_pk from dual;
		insert into CONCEPT (CON_ID, CON_SCH_ID,PARENT_CONCEPT_ID,CL_ID) VALUES (p_pk, p_con_sch_id,p_parent_con_id,p_cl_id);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_CODELIST(
	p_id IN varchar2,
	p_version IN varchar2,
	p_agency IN varchar2,
	p_valid_from IN  timestamp DEFAULT NULL,
	p_valid_to IN  timestamp DEFAULT NULL,
	p_is_final IN number DEFAULT NULL,
	p_uri IN nvarchar2,
	p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number default 0,
	p_pk OUT NUMBER)
AS
BEGIN

	INSERT_ITEM_SCHEME(p_id => p_id,p_version => p_version,p_agency => p_agency,p_valid_from => p_valid_from,p_valid_to => p_valid_to,p_is_final => p_is_final,p_uri => p_uri, p_last_modified => p_last_modified,p_pk => p_pk);
	
	INSERT INTO CODELIST
           (CL_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_STRUCTURE_USAGE(
 p_id IN varchar2,
 p_version IN  varchar2,
 p_agency IN varchar2,
 p_valid_from IN   timestamp,
 p_valid_to IN   timestamp,
 p_is_final IN  number,
 p_uri IN  nvarchar2,
 p_last_modified IN  timestamp,
 p_pk OUT  number)
IS
BEGIN
	 INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
     insert into STRUCTURE_USAGE (SU_ID) VALUES (p_pk);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_METADATAFLOW(
 p_id IN varchar2,
 p_version IN  varchar2,
 p_agency IN varchar2,
 p_valid_from IN   timestamp DEFAULT NULL,
 p_valid_to IN   timestamp DEFAULT NULL,
 p_is_final IN  number,
 p_uri IN  nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
 p_msd_id IN  number,
 p_pk OUT number)
IS
BEGIN
	 INSERT_STRUCTURE_USAGE(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	 INSERT INTO METADATAFLOW
           (MSD_ID,MDF_ID)
     VALUES
           (p_msd_id,p_pk);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_MSD(
 p_id IN varchar2,
 p_version IN  varchar2,
 p_agency IN varchar2,
 p_valid_from IN   timestamp DEFAULT NULL,
 p_valid_to IN   timestamp DEFAULT NULL,
 p_is_final IN  number,
 p_uri IN  nvarchar2,
 p_last_modified IN  timestamp DEFAULT NULL,
 p_pk OUT  number)
IS
BEGIN
	INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	INSERT INTO METADATA_STRUCTURE_DEFINITION
           (MSD_ID)
     VALUES
           (p_pk);
	
END;
/

CREATE OR REPLACE PROCEDURE INSERT_METADATA_TARGET(
 p_id IN  varchar2,
 p_MSD_ID IN number,
 p_pk OUT  number)
IS
BEGIN
		insert into ITEM (ID) VALUES (p_id);
		select ITEM_SEQ.currval into p_pk from dual;
		insert into METADATA_TARGET (MDT_ID,MSD_ID) VALUES (p_pk,p_MSD_ID);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_TARGET_OBJECT(
 p_id IN varchar2,
 p_ITEM_SCHEME_ID IN number,
 p_MDT_ID IN number,
 p_TYPE IN varchar2,
 p_pk OUT  number)
IS
BEGIN
		INSERT_COMPONENT_COMMON(p_pk);
		insert into TARGET_OBJECT (TARGET_OBJ_ID,ID,ITEM_SCHEME_ID,MDT_ID,TYPE) VALUES (p_pk,p_id,p_ITEM_SCHEME_ID,p_MDT_ID,p_TYPE);
END;
/



CREATE OR REPLACE PROCEDURE INSERT_REPORT_STRUCTURE(
 p_id IN  varchar2,
 p_MSD_ID IN number,
 p_pk OUT  number)
IS
BEGIN
	insert into ITEM (ID) VALUES (p_id);
		select ITEM_SEQ.currval into p_pk from dual;
		insert into REPORT_STRUCTURE (RS_ID,MSD_ID) VALUES (p_pk,p_MSD_ID);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_METADATA_ATTRIBUTE(
 p_id IN varchar2,
    p_MIN_OCCURS IN  number,
 p_MAX_OCCURS IN  number,
 p_IS_PRESENTATIONAL IN  Number,
 p_PARENT IN  number,
 p_CON_ID IN  number,
 p_CL_ID IN  number,
 p_RS_ID IN  number,
 p_pk OUT  number)
IS
BEGIN
 INSERT_COMPONENT_COMMON(p_pk);
	INSERT INTO METADATA_ATTRIBUTE
           (MTD_ATTR_ID,ID,MIN_OCCURS,MAX_OCCURS,IS_PRESENTATIONAL,PARENT,CON_ID,CL_ID,RS_ID)
     VALUES
           (p_pk,p_id,p_MIN_OCCURS,p_MAX_OCCURS,p_IS_PRESENTATIONAL,p_PARENT,p_CON_ID,p_CL_ID,p_RS_ID);
	
END;
/




CREATE OR REPLACE PROCEDURE INSERT_COMPONENT_COMMON(
 p_pk OUT number
	)
IS
BEGIN
	INSERT INTO COMPONENT_COMMON  values (NULL);
	select COMPONENT_SEQ.currval into p_pk from dual;
END;
/


CREATE OR REPLACE PROCEDURE INSERT_ITEM_SCHEME(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
 p_pk OUT number)
IS
BEGIN
    INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	insert into ITEM_SCHEME (ITEM_SCHEME_ID) VALUES (p_pk);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_PROVISION_AGREEMENT(
 p_id IN varchar2,
    p_version IN  varchar2,
    p_agency IN varchar2,
    p_valid_from IN   timestamp DEFAULT NULL,
    p_valid_to IN   timestamp DEFAULT NULL,
    p_is_final IN  number,
    p_uri IN  nvarchar2,
 p_last_modified IN  timestamp DEFAULT NULL,
 p_su_id IN number,
 p_dp_id IN number,
 p_pk OUT  number)
IS
BEGIN
	INSERT_ARTEFACT(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	INSERT INTO PROVISION_AGREEMENT
           (PA_ID,SU_ID,DP_ID)
     VALUES
           (p_pk,p_su_id,p_dp_id);
	
END;
/

CREATE OR REPLACE PROCEDURE INSERT_CATEGORY_SCHEME(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number,
 p_pk OUT number)
IS
BEGIN
 INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO CATEGORY_SCHEME
           (CAT_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_CONCEPT_SCHEME(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number,
 p_pk OUT number)
IS
BEGIN
	INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO CONCEPT_SCHEME
           (CON_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_DATACONSUMER_SCHEME(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number,
 p_pk OUT number)
IS
BEGIN
 INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO DATACONSUMER_SCHEME
           (DC_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/


CREATE OR REPLACE PROCEDURE INSERT_DATAPROVIDER_SCHEME(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number,
 p_pk OUT number)
IS
BEGIN
	INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	INSERT INTO DATAPROVIDER_SCHEME
           (DP_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_ORGANISATION_UNIT_SCH(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number,
 p_pk OUT number)
IS
BEGIN
 INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
	INSERT INTO ORGANISATION_UNIT_SCHEME
           (ORG_UNIT_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_AGENCY_SCHEME(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
    p_is_partial IN number,
 p_pk OUT number)
IS
BEGIN
	INSERT_ITEM_SCHEME (p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	INSERT INTO AGENCY_SCHEME
           (AG_SCH_ID, IS_PARTIAL)
     VALUES
           (p_pk, p_is_partial);
END;
/

CREATE OR REPLACE PROCEDURE INSERT_DATAFLOW(
 p_id IN varchar2,
 p_version IN varchar2,
 p_agency IN varchar2,
 p_valid_from IN timestamp DEFAULT NULL,
 p_valid_to IN timestamp DEFAULT NULL,
 p_is_final IN number,
 p_uri IN nvarchar2,
 p_last_modified IN timestamp DEFAULT NULL,
 p_dsd_id IN number,
 p_map_set_id IN number,
 p_pk OUT number)
IS
BEGIN
     INSERT_STRUCTURE_USAGE(p_id,p_version,p_agency,p_valid_from,p_valid_to,p_is_final,p_uri,p_last_modified, p_pk);
	
INSERT INTO DATAFLOW
           (DF_ID
           ,DSD_ID
           ,MAP_SET_ID)
     VALUES
           (p_pk
           ,p_dsd_id
           ,p_map_set_id);
END;
/
CREATE TABLE REGISTRATION (
    DR_ID NUMBER(18) NOT NULL,
    ID VARCHAR2(50) NULL,
    VALID_FROM TIMESTAMP NULL,
    VALID_TO TIMESTAMP NULL,
    LAST_UPDATED TIMESTAMP NULL,
    INDEX_TIME_SERIES NUMBER(1) DEFAULT 0 NOT NULL,
    INDEX_DATA_SET NUMBER(1) DEFAULT 0 NOT NULL,
    INDEX_ATTRIBUTES NUMBER(1) DEFAULT 0 NOT NULL,
    INDEX_REPORTING_PERIOD NUMBER(1) DEFAULT 0 NOT NULL,
    PA_ID NUMBER(18) NOT NULL,
    DATA_SOURCE_ID NUMBER(18) NOT NULL,
    PRIMARY KEY(DR_ID)
) 
;

CREATE TABLE DATA_SOURCE (
   DATA_SOURCE_ID NUMBER(18) NOT NULL,
   -- ID VARCHAR(50) NULL, Doubled checked and doesn't appear to be a need for an ID.
   DATA_URL nvarchar2(500) NOT NULL,
   WSDL_URL nvarchar2(500) NULL,
   WADL_URL nvarchar2(500) NULL,
   IS_SIMPLE NUMBER(1) NOT NULL,
   IS_REST NUMBER(1) NOT NULL,
   IS_WS NUMBER(1) NOT NULL,
   PRIMARY KEY(DATA_SOURCE_ID)
) 
;

alter table REGISTRATION add constraint FK_REGISTRATION_PROVISION foreign key (PA_ID) 
references PROVISION_AGREEMENT (PA_ID)
;

alter table REGISTRATION add constraint FK_REGISTRATION_DATASOURCE foreign key (DATA_SOURCE_ID)
references DATA_SOURCE (DATA_SOURCE_ID)
ON DELETE CASCADE
;

CREATE SEQUENCE REGISTRATION_DR_ID_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;

CREATE SEQUENCE DATA_SOURCE_ID_SEQ
INCREMENT BY 1
START WITH 1
NOMAXVALUE
MINVALUE 1
NOCYCLE
NOCACHE
NOORDER
;

CREATE OR REPLACE TRIGGER SET_DR_ID
BEFORE INSERT
ON REGISTRATION
FOR EACH ROW
BEGIN
  select REGISTRATION_DR_ID_SEQ.NEXTVAL into :NEW.DR_ID FROM DUAL;
END;
/

CREATE OR REPLACE TRIGGER SET_DATA_SOURCE_ID
BEFORE INSERT
ON DATA_SOURCE
FOR EACH ROW
BEGIN
  select DATA_SOURCE_ID_SEQ.NEXTVAL into :NEW.DATA_SOURCE_ID FROM DUAL;
END;
/
create or replace procedure INSERT_DATA_SOURCE (
	p_data_url IN nvarchar2,
	p_wsdl_url IN nvarchar2,
	p_wadl_url IN nvarchar2,
	p_is_simple IN NUMBER,
	p_is_rest IN NUMBER,
	p_is_ws IN NUMBER,
	p_pk OUT NUMBER)
AS
BEGIN
	insert into DATA_SOURCE (DATA_URL, WSDL_URL, WADL_URL, IS_SIMPLE, IS_REST, IS_WS) 
    values (p_data_url, p_wsdl_url, p_wadl_url, p_is_simple, p_is_rest, p_is_ws);
  select DATA_SOURCE_ID_SEQ.currval into p_pk from dual;
END;
/
create or replace procedure INSERT_REGISTRATION (
	p_id IN varchar2,
	p_valid_from IN TIMESTAMP,
	p_valid_to IN TIMESTAMP,
	p_last_updated IN TIMESTAMP,
	p_index_ts IN NUMBER,
	p_index_ds IN NUMBER,
	p_index_attributes IN NUMBER,
	p_index_reporting_period IN NUMBER,
	p_pa_id IN NUMBER,
	p_datasource_id IN NUMBER,
	p_pk OUT NUMBER)
AS
BEGIN
	insert into REGISTRATION (ID, VALID_FROM, VALID_TO, LAST_UPDATED, INDEX_TIME_SERIES, INDEX_DATA_SET, INDEX_ATTRIBUTES, INDEX_REPORTING_PERIOD, PA_ID, DATA_SOURCE_ID) 
    values (p_id, p_valid_from, p_valid_to, p_last_updated, p_index_ts, p_index_ds, p_index_attributes, p_index_reporting_period, p_pa_id, p_datasource_id);
	select REGISTRATION_DR_ID_SEQ.currval into p_pk from dual;
END;
/

update DB_VERSION SET VERSION = '5.0'
;
